import { CoordinateData, SeriesHierarchy, SeriesStyle, SeriesType } from '../../types/types';
export declare class ElementStrategyFactory {
    static get(primaryType: SeriesType, primarySeries: any): any;
    static establishSeriesHierarchy(pieComponents: any, stackedComponents: any, columnComponents: any, scatterComponents: any, lineComponents: any): SeriesHierarchy;
}
export declare class CoreFuncs {
    data?: any;
    constructor(data?: any);
    coreFormatData(axisConfigs: any, data?: any): any;
    formatPrimaryData(axisConfigs: any, data?: any): any;
    flatten(data: CoordinateData[][]): CoordinateData[];
    getTargetingData(data: CoordinateData[][]): CoordinateData[];
    xAxisTypeOverride(axisConfigs: any): any;
    getDims(chartContainer: any): {
        height: number;
        width: number;
        margin: {
            top: number;
            right: number;
            bottom: number;
            left: number;
        };
    };
    getDefaultXAxisConfig(): any;
    getDefaultYAxisConfig(): any;
    usesAxis(): boolean;
}
export declare abstract class ChartService {
    abstract arrow(): boolean;
    abstract flatten(data: CoordinateData[] | CoordinateData[][]): CoordinateData[];
    abstract getPopoverEl(svg: any, index: number): HTMLElement;
    abstract getPopoverPlacement(): string;
    abstract getSeriesStyle(): SeriesStyle;
    abstract getTargetingData(data: CoordinateData[] | CoordinateData[][]): CoordinateData[];
    abstract isMultiSeries(): boolean;
    abstract usesAxis(): boolean;
}
export declare class SingleSeriesChartStrategy extends CoreFuncs implements ChartService {
    arrow(): boolean;
    getPopoverEl(svg: any, index: number): HTMLElement;
    getPopoverPlacement(): string;
    getSeriesStyle(): SeriesStyle;
    isMultiSeries(): boolean;
    getPopoverSeriesStyle(): SeriesStyle;
}
export declare class MultiSeriesChartStrategy extends CoreFuncs implements ChartService {
    arrow(): boolean;
    getPopoverEl(svg: any, index: number): HTMLElement;
    getPopoverPlacement(): string;
    getSeriesStyle(): SeriesStyle;
    isMultiSeries(): boolean;
    getPopoverSeriesStyle(): SeriesStyle;
}
export declare class StackedSeries extends MultiSeriesChartStrategy {
    formatPrimaryData(axisConfigs: any, data?: any): {
        data: any;
        stackedData: import("d3-shape").Series<{
            [key: string]: number;
        }, string>[];
        minMax: {
            min: number;
            max: number;
        };
    };
}
export declare class SingleScatterSeries extends SingleSeriesChartStrategy {
    xAxisTypeOverride(axisConfigs: any): any;
}
export declare class MultiScatterSeries extends MultiSeriesChartStrategy {
    xAxisTypeOverride(axisConfigs: any): any;
}
export declare class SingleLineSeries extends SingleSeriesChartStrategy {
    xAxisTypeOverride(axisConfigs: any): any;
}
export declare class MultiLineSeries extends MultiSeriesChartStrategy {
    xAxisTypeOverride(axisConfigs: any): any;
}
export declare class SingleColumnSeries extends SingleSeriesChartStrategy {
    getPopoverSeriesStyle(): SeriesStyle;
}
export declare class MultiColumnSeries extends MultiSeriesChartStrategy {
    arrow(): boolean;
    getPopoverPlacement(): string;
    getPopoverSeriesStyle(): SeriesStyle;
}
export declare class PieSeries extends SingleSeriesChartStrategy {
    usesAxis(): boolean;
    getPopoverPlacement(): string;
}
